//-----------------------------------------------
//API for TUSB-0216AD Driver
//Visual C++/CLI Module
//
//Feb. 05 2014
//Copyright (C) 2014 Turtle Industry Co.,Ltd.
//-----------------------------------------------

#ifndef TUSB16AD_h
#define TUSB16AD_h

using namespace System;
using namespace System::Runtime::InteropServices;

[DllImport("TUSB16AD.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short TUSB0216AD_Device_Open(short Id);
[DllImport("TUSB16AD.DLL", CallingConvention = CallingConvention::Cdecl)]
extern void TUSB0216AD_Device_Close(short Id);
[DllImport("TUSB16AD.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short TUSB0216AD_DIO_In(short Id,unsigned char *Data);
[DllImport("TUSB16AD.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short TUSB0216AD_DIO_Out(short Id,unsigned char Data);
[DllImport("TUSB16AD.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short TUSB0216AD_DIO_Chk(short Id,unsigned char *Data);
[DllImport("TUSB16AD.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short TUSB0216AD_Ad_Single(short Id,[Out] int Data[]);
[DllImport("TUSB16AD.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short TUSB0216AD_Start(short Id,unsigned char Ch,int PreLen,unsigned char TrgType,unsigned char TrgCh);
[DllImport("TUSB16AD.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short TUSB0216AD_Stop(short Id);
[DllImport("TUSB16AD.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short TUSB0216AD_Ad_Status(short Id, unsigned char *Status, [Out] unsigned char OverFlow[], [Out] int DataLen[]);
[DllImport("TUSB16AD.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short TUSB0216AD_Ad_Data(short Id,unsigned char Ch, [Out] int Data[], int *DataLen);
[DllImport("TUSB16AD.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short TUSB0216AD_AdClk_Set(short Id, int ClkTime, unsigned char Sel);
[DllImport("TUSB16AD.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short TUSB0216AD_Level_Set(short Id, int Level, short Hys);
[DllImport("TUSB16AD.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short TUSB0216AD_Input_Set(short Id, unsigned char Type1, unsigned char Type2);
[DllImport("TUSB16AD.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short TUSB0216AD_Trigger(short Id);
[DllImport("TUSB16AD.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short TUSB0216AD_Input_Check(short Id, unsigned char *Type1, unsigned char *Type2);

static String^ TUSB0216AD_GetErrMessage(short retcode)
{
    switch (retcode)
    {
        case 0:
            return "I܂";
        case 1:
            return "IDԍsł";
        case 2:
            return "hCoCXg[Ă܂";
        case 3:
            return "łɃfoCX̓I[vĂ܂";
        case 4:
            return "ڑĂ䐔܂";
        case 5:
            return "I[vł܂ł";
        case 6:
            return "foCX݂܂";
        case 8:
            return "p[^G[";
        case 9:
            return "USBʐMG[ł";
        case 11:
            return "A捞쒆ł";
        default:
            return "sȃG[ł";
    }
}
#endif
