'-----------------------------------------------
'API for TUSB-0216AD Driver
'Visual Basic Module
'
'Apr. 02 2012
'Copyright (C) 2008 Turtle Industry Co.,Ltd.
'-----------------------------------------------
Option Strict Off
Option Explicit On
Imports System.Runtime.InteropServices

Module TUSB16AD

    'API Function declaration

    <DllImport("TUSB16AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSB0216AD_Device_Open(ByVal Id As Short) _
                           As Short
    End Function
    <DllImport("TUSB16AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Sub TUSB0216AD_Device_Close(ByVal Id As Short)
    End Sub
    <DllImport("TUSB16AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSB0216AD_DIO_In(ByVal Id As Short, _
                               ByRef Data As Byte) _
                           As Short
    End Function
    <DllImport("TUSB16AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSB0216AD_DIO_Out(ByVal Id As Short, _
                               ByVal Data As Byte) _
                           As Short
    End Function
    <DllImport("TUSB16AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSB0216AD_DIO_Chk(ByVal Id As Short, _
                               ByRef Data As Byte) _
                           As Short
    End Function
    <DllImport("TUSB16AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSB0216AD_Ad_Single(ByVal Id As Short, _
                               <Out()> ByVal Data() As Integer) _
                           As Short
    End Function
    <DllImport("TUSB16AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSB0216AD_Start(ByVal Id As Short, _
                              ByVal Ch As Byte, _
                              ByVal PreLen As Integer, _
                              ByVal TrgType As Byte, _
                              ByVal TrgCh As Byte) _
                          As Short
    End Function
    <DllImport("TUSB16AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSB0216AD_Stop(ByVal Id As Short) _
                          As Short
    End Function
    <DllImport("TUSB16AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSB0216AD_Ad_Status(ByVal Id As Short, _
                                  ByRef Status As Byte, _
                                  <Out()> ByVal OverFlow() As Byte, _
                                  <Out()> ByVal DataLen() As Integer) _
                          As Short
    End Function
    <DllImport("TUSB16AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSB0216AD_Ad_Data(ByVal Id As Short, _
                                ByVal Ch As Byte, _
                                <Out()> ByVal Data() As Integer, _
                                ByRef DataLen As Integer) _
                          As Short
    End Function
    <DllImport("TUSB16AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSB0216AD_AdClk_Set(ByVal Id As Short, _
                                  ByVal ClkTime As Integer, _
                                  ByVal Sel As Byte) _
                          As Short
    End Function
    <DllImport("TUSB16AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSB0216AD_Level_Set(ByVal Id As Short, _
                                  ByVal Level As Integer, _
                                  ByVal Hys As Short) _
                          As Short
    End Function
    <DllImport("TUSB16AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSB0216AD_Input_Set(ByVal Id As Short, _
                                  ByVal Type1 As Byte, _
                                  ByVal Type2 As Byte) _
                          As Short
    End Function
    <DllImport("TUSB16AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSB0216AD_Trigger(ByVal Id As Short) _
                          As Short
    End Function
    <DllImport("TUSB16AD.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function TUSB0216AD_Input_Check(ByVal Id As Short, _
                                    ByRef Type1 As Byte, _
                                    ByRef Type2 As Byte) _
                          As Short
    End Function

    ' Error Message
    Public Sub TUSB0216AD_ErrorDisp(ByVal ErrCode As Short)
        Dim message As String

        Select Case ErrCode
            Case 0
                message = "ɏI܂"
            Case 2
                message = "hCoĂ܂"
            Case 6
                message = "foCX܂ł"
            Case 8
                message = "p[^G["
            Case 9
                message = "USBʐMG["
            Case 11
                message = "A荞ݓ쒆ł"
            Case Else
                message = "sȃG[ł"
        End Select

        MsgBox(message)
    End Sub
End Module